define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var Data = require("$UI/system/components/justep/data/data");

	var Model = function(){
		this.showFilterGird = justep.Bind.observable(false);
		this.initOK = justep.Bind.observable(false);
		this.result = justep.Bind.observable();

		this.canOK = justep.Bind.computed(function(){
			if(!this.initOK.get()) return false;
			if(this.getSelected()) return true;
			else return false;
		},this);

		this.callParent();
	};

	Model.prototype.getSelected = function(){
		return this.result.get();
	};

	Model.prototype.OKBtnClick = function(event){
		var dialogData = this.comp("dialogData");
		var grid = this.comp("treeGrid");
		var rows = [];
		$.each(grid.getCheckeds(), function(i, id) {
			var row = dialogData.getRowByID(id);
			rows.push(row);
		});
		this.comp("windowReceiver").windowEnsure(rows);
	};

	Model.prototype.getTreeData = function(){
		return this.comp('dialogData');
	};

	Model.prototype.setSelected = function(selected) {
		return this.result.set(selected);
	};

	Model.prototype.windowReceiverReceive = function(event){
		if(event.data){
			if(event.data.selected){
				this.setSelected(event.data.selected);
			}
		}
		this.initOK.set(true);
	};

	Model.prototype.smartFilterFilter = function(event){
		var filter = event.source;
		var v = filter.getFilterStr();
		if(v){
			this.showFilterGird.set(true);
			$(this.getElementsByXid('searchDiv')).css({height:'100%',position: 'relative'});
			var searchData = this.comp('searchData');
			searchData.setFilter(filter.getFilterFlag(), filter.getFilterStr());
			searchData.refreshData();
		}else{
			this.showFilterGird.set(false);
			$(this.getElementsByXid('searchDiv')).css({height:0,position: 'absolute'});
			this.comp('treeGrid').autoSize();
		}
		this.setSelected(null);
	};

	Model.prototype.treeGridRowClick = function(event){
		this.setSelected(this.getTreeData().getRowByID(event.rowID));
	};

	Model.prototype.searchGridRowSelect = function(event){
		this.setSelected(event.row);
	};

	Model.prototype.treeGridRowChecked = function(event){
		var fParent = event.row.val("sParent");//获取当前行的父ID
		var grid = this.comp("treeGrid");
		var data = this.comp("dialogData");
		var checkRows = event.source.getCheckedRows();//获取当前多选的行
		if (fParent !== undefined) {
			var parentRow = event.source.getRowByID(fParent);//根据父ID获取父的行
			if (event.checked) {//判断是否是选中
				if (!grid.isChecked(fParent)) {//如果父的行上没有选中的就设置选中
					grid.setRowChecked (fParent,true);
				}
			} else {//取消选中
				var fParents = [];
				for ( var rows in checkRows) {
					fParents.push(data.getValue("sParent", checkRows[rows]));//遍历当前多选的行，获取这些行的父ID并放到fParents中
				}
				if ($.inArray(fParent, fParents) == -1) {//判断fParents中是否有当前取消选中行的父ID
					grid.setRowChecked (fParent,false);
				}
			}
		}
	};


	return Model;
});